// $Date:: 2009-08-16 16:52:59 +0900#$
// $Rev: 3 $

#include "AniNR.h"
#include <math.h>

//#define PRINTTIME
#ifdef PRINTTIME
#include <stdio.h>
#include <mmsystem.h>
#pragma comment ( lib , "winmm.lib" )
static __int32 tcount = 0 ;
#endif

// Robinson Iy[^{cP{oIy[^
static const int templ[6][3][3]={{
    { 1, 2, 1},
    { 0, 0, 0},
    {-1,-2,-1}},{
    { 1, 0,-1},
    { 2, 0,-2},
    { 1, 0,-1}},{
    { 2, 1, 0},
    { 1, 0,-1},
    { 0,-1,-2}},{
    { 0, 1, 2},
    {-1, 0, 1},
    {-2,-1, 0}},{
    {-1,-2,-1},
    { 2, 4, 2},
    {-1,-2,-1}},{
    {-1, 2,-1},
    {-2, 4,-2},
    {-1, 2,-1}}};

/**************************************************************************************************/
/* AniNR                                                                                      */
/**************************************************************************************************/
//==============================================================================
// constructor
//==============================================================================
AniNR::AniNR(PClip _child, int strength, int threshold1, int threshold2, IScriptEnvironment* env) : GenericVideoFilter(_child)
{
    this->Height    = this->vi.height ;
    this->Width     = this->vi.width ;
    
    // mCYxB0`20 ͈̔͂ŏB
    this->Strength  = strength ;

    // GbWo臒lB0`255 ͈̔͂ŏB
    this->Threshold1 = threshold1 ;

    // ڂ臒lB0`255 ͈̔͂ŏB
    this->Threshold2 = threshold2 ;

    // Zx->mCYlϊs̐B
    // dݕt`ŁAZx threshold1 菬͈͂͊SA
    // threshold1`2*threshold1͈̔͂͂P`dݕtōA
    // 2*threshold1傫͈͍͂ȂB
    for ( int i = -255 ; i < 256 ; i ++ )
    {
        if ( abs ( i ) < this->Threshold2 ) this->W [ i + 255 ] = i ;
        else if ( abs ( i ) >= 2 * this->Threshold2 ) this->W [ i + 255 ] = 0 ;
        else this->W [ i + 255 ] = ( 2 * this->Threshold2 - abs ( i ) ) * i / this->Threshold2 ;
    }
}

//==============================================================================
// destructor
//==============================================================================
AniNR::~AniNR()
{
#ifdef PRINTTIME
    char strtime [ 256 ] ;
    _snprintf ( strtime , sizeof (strtime) , "%f\r\n" , ( (float) tcount ) / 1000 ) ;
    OutputDebugString ( strtime ) ;
#endif // PRINTTIME
}

//==============================================================================
// GetFrame
//==============================================================================
PVideoFrame AniNR::GetFrame (int n, IScriptEnvironment* env)
{
    PVideoFrame src = this->child->GetFrame ( n , env ) ;
    env->MakeWritable ( & src ) ;

    BYTE* pSrcY = src->GetWritePtr () ;
    const int nSrcYPitch = src->GetPitch();
    int * pWk [ 4 ] ;
    BYTE * pCur ;

#ifdef PRINTTIME
    tcount -= timeGetTime () ;
#endif // PRINTTIME

    // [Nt
    for ( int i = 0 ; i < 3 ; i ++ )
        pWk [ i ] = (int*) malloc ( this->Width * sizeof (int) ) ;

    // QCɕKv
    for ( int j = 0 ; j < 2 ; j ++ )
    {
        // RsNZ̘avZ
        pCur = pSrcY + ( j + 1 ) * nSrcYPitch + 1 ;
        for ( int i = 2 ; i < this->Width - 2 ; i ++ , pCur ++ )
            pWk [ j ][ i ] = pCur [ 0 ] + pCur [ 1 ] + pCur [ 2 ] ;
    }

    // vZ
    float fStrength = ( (float) this->Strength ) / 20 ;

    // sNZƂɏ
    // ͂QsNZ͏Ȃ
    for ( int j = 2 ; j < this->Height - 2 ; j ++ )
    {
        // RsNZ̘avZ
        pCur = pSrcY + ( j + 1 ) * nSrcYPitch + 1 ;
        for ( int i = 2 ; i < this->Width - 2 ; i ++ , pCur ++ )
            pWk [ 2 ][ i ] = pCur [ 0 ] + pCur [ 1 ] + pCur [ 2 ] ;

        pCur = pSrcY + j * nSrcYPitch + 2 ;
        for ( int i = 2 ; i < this->Width - 2 ; i ++ , pCur ++ )
        {
            // GbWxvZ
            // RsNZacRAX{lƂ킹āA
            // 3x3 vVAɂGbWxZoB
            int chk = 9 * ( * pCur ) - pWk [ 0 ][ i ] - pWk [ 1 ][ i ] - pWk [ 2 ][ i ] ;
            int kind = 0 ;

            if ( abs ( chk ) >= this->Threshold1 )
            {
                // GbWx臒l𒴂Ă
                // GbWp^[vZ
                int maskv[6]={0};
                for ( int yy = 0 ; yy < 3 ; yy ++ )
                {
                    for ( int xx = 0 ; xx < 3 ; xx ++ )
                    {
                        // Zxz̎Zo
                        int val = pSrcY[(j+yy-1)*nSrcYPitch+i+xx-1] ;
                        maskv[0] += val*templ[0][xx][yy];
                        maskv[1] += val*templ[1][xx][yy];
                        maskv[2] += val*templ[2][xx][yy];
                        maskv[3] += val*templ[3][xx][yy];
                        maskv[4] += val*templ[4][xx][yy];
                        maskv[5] += val*templ[5][xx][yy];
                    }
                }
                // P{oIy[^͋xQ{ɂȂĂ̂ŁAQŊ
                maskv[4] >>= 1 ;
                maskv[5] >>= 1 ;

                // GbW
                for ( int k = 0 ; k < 6 ; k ++ )
                {
                    // ƂZxzT
                    maskv [ k ] = abs ( maskv [ k ] ) ;
                    if ( maskv [ kind ] < maskv [ k ] ) kind = k ;
                }

                // ܉΍BZxz̋xA
                // vVAɂ鋭xȂAア
                // ƍlA܉mCYƂ݂ȂAGbWȂB
                // "chk * 0.5" K؂̂悤Ɏvꂽ̂ǁA
                // ܂育܉Ƃ݂ȂȂق悳̂ 0.4B
                // ݒŕύXł悤ɂقǂȂBBB
                if ( maskv [ kind ] < abs ( (int) ( chk * 0.4 ) ) ) kind = -2 ;
            }
            else
            {
                // GbW臒l
                kind = -1 ;
            }

            // Zxzƒsɂ̂ݍs
            int wk , wk1 ;
            switch ( kind )
            {
#define M_CALCNR(a1,a2,a3,a4) { \
    wk1 = pSrcY[j*nSrcYPitch+i] + 255 ; \
    wk = ( this->W [ wk1 - a1 ] + \
           this->W [ wk1 - a2 ] + \
           this->W [ wk1 - a3 ] + \
           this->W [ wk1 - a4 ] ) >> 2 ; \
}
            case 0 : // ̌z
            case 4 : // c{
                M_CALCNR ( pSrcY[(j-2)*nSrcYPitch+i] ,
                           pSrcY[(j-1)*nSrcYPitch+i] ,
                           pSrcY[(j+1)*nSrcYPitch+i] ,
                           pSrcY[(j+2)*nSrcYPitch+i] ) ;
                break ;

            case 1 : // čz
            case 5 : // {
                M_CALCNR ( pSrcY[j*nSrcYPitch+i-2] ,
                           pSrcY[j*nSrcYPitch+i-1] ,
                           pSrcY[j*nSrcYPitch+i+1] ,
                           pSrcY[j*nSrcYPitch+i+2] ) ;
                break ;

            case 2 : // ̌z
                M_CALCNR ( pSrcY[(j-2)*nSrcYPitch+i+2] ,
                           pSrcY[(j-1)*nSrcYPitch+i+1] ,
                           pSrcY[(j+1)*nSrcYPitch+i-1] ,
                           pSrcY[(j+2)*nSrcYPitch+i-2] ) ;
                break ;

            case 3 : // Ěz
                M_CALCNR ( pSrcY[(j-2)*nSrcYPitch+i-2] ,
                           pSrcY[(j-1)*nSrcYPitch+i-1] ,
                           pSrcY[(j+1)*nSrcYPitch+i+1] ,
                           pSrcY[(j+2)*nSrcYPitch+i+2] ) ;
                break ;

            case -1 : // GbW臒l
            case -2 : // ܉mCY
            default :
                wk = chk / 9 ;
                break ;
#undef M_CALCNR
            }
            pSrcY [j*nSrcYPitch+i] -= (int) ( wk * fStrength ) ;
            //pSrcY [j*nSrcYPitch+i] = ( kind == -1 || kind == 4 ) ? 0 : 255 ;
        }
        pWk [ 3 ] = pWk [ 0 ] ;
        pWk [ 0 ] = pWk [ 1 ] ;
        pWk [ 1 ] = pWk [ 2 ] ;
        pWk [ 2 ] = pWk [ 3 ] ;
    }
    for ( int i = 0 ; i < 3 ; i ++ ) free ( pWk [ i ] ) ;

#ifdef PRINTTIME
    tcount += timeGetTime () ;
#endif // PRINTTIME
    return src ;
}
